--This is forms. This is by far the most important in a project, they contain all of the controls and as of right now the only things that can recieve input
form = class(window)

function form:init(x, y, width, height, fullscreen, title, titlecolor, bordercolor, isdrawn, contextmenu, cmtable)
	self.focused = false
	self.fullscreen = fullscreen
	self.titlecolor = titlecolor
	self.x = x + 1
	self.y = y + 20
	self.height = height
	self.width = width - 2
	self.titlebarx = x
	self.titlebary = y
	self.titlebarwidth = width
	self.titlebarheight = 20
	self.title = title
	self.cirbwidth = 5
	self.cirbheight = 5
	self.cirbx = self.titlebarx + (self.titlebarwidth / 2) - 4
	self.cirby =  (self.titlebary + self.titlebarheight / 4) - 2
	self.bordercolor = bordercolor
	self.isdrawn = isdrawn
	self.contextmenu = contextmenu
	self.cmtable = cmtable
	self.valsavelist = {}
	self.controls = {}
	self.dialogs = {}
	self.allowevents = true
	self.moveable = false
	if #wndTbl == nil then
		table.insert(wndTbl, self)
	else
		table.insert(wndTbl, 1, self)
	end
	if self.contextmenu then
		mycm = contextm( self, self.cmtable)
	end
	if self.x == platform.window:width() and self.y == platform.window:height() then
		self.valsavelist = {
		x = {0},
		y = {0},
		width = {100},
		height = {100}}
		self.fullscreen = true
	end
	if curwin() == nil then
		self.focused = self:getFocus()
	end
	if self.fullscreen then
		self:setFull()
	end
end
function form:paint(gc)
	if self.isdrawn then
		if self.focused then
			gc:setColorRGB(unpack(self.bordercolor))
		else
			gc:setColorRGB(unpack(color.Bdark))
		end
		if not(self.fullscreen) then
			gc:fillRect(self.titlebarx, self.titlebary, self.titlebarwidth, self.height)
			gc:setColorRGB(unpack(color.Bcontrol))
			gc:fillRect(self.x, self.y, self.width, self.height - 22)
		else
			gc:fillRect(self.titlebarx, self.titlebary, platform.window:width(), platform.window:height())
			gc:setColorRGB(unpack(color.Bcontrol))
			gc:fillRect(self.x, self.y, self.width, self.height - 22)
		end
		if self.fullscreen then
			gc:setColorRGB(unpack(color.yellow))
		else
			gc:setColorRGB(unpack(color.green))
		end
		gc:fillArc(self.cirbx, self.cirby, self.cirbwidth, self.cirbheight, 0, 360)
		gc:setColorRGB(unpack(color.red))
		gc:fillArc(self.cirbx + 8, self.cirby, self.cirbwidth, self.cirbheight, 0, 360)
		for _, dialog in pairs(self.dialogs) do
			dialog:paint(gc)
		end
		gc:setColorRGB(unpack(self.titlecolor))
		gc:setFont("sansserif", "r", 6)
		gc:drawString(self.title, self.titlebarx + 3, self.cirby + 2, "top")
		if self.contextmenu then
			mycm.x = self.x
			mycm.y = self.y
			mycm.width = self.width
		end
		for _, control in pairs(self.controls) do
			if not(control == mycm) then
				self:udateControl(control)
			end
			control:paint(gc)
		end
		for _, dialog in pairs(self.dialogs) do
			dialog:paint(gc)
		end
	end
end
function form:checkUnclick()
	self.moveable = false
	cursor.set("default")
	I()
end
function form:close()
	self.focused = false
	self.isdrawn = false
	self.moveable = false
	cursor.set("default")
	for _, dialog in pairs(self.dialogs) do
		dialog.isdrawn = false
	end
	I()
end
function form:wasclicked(x, y)
	if not(self.focused) then
		self.focused = self:getFocus()
	end
	self.moveable = true
	self.xvar = x - self.titlebarx
	self.yvar = y - self.titlebary
	cursor.set("drag grab")
	I()
end
function form:setFull()
	self.fullscreen = true
	self:saveSettings()
	I()
end
function form:saveSettings()
	if not(self.focused) then
		self.focused = self:getFocus()
	end
	self.valsavelist = {
		x = {self.titlebarx},
		y = {self.titlebary},
		width = {self.titlebarwidth},
		height = {self.height},
		bx = {self.x},
		by = {self.y},
		bw = {self.width},
		cirbx = {self.cirbx},
		cirby = {self.cirby}}
	self.titlebarx = 0
	self.titlebary = 0
	self.titlebarheight = 20
	self.x = self.titlebarx + 1
	self.height = platform.window:height()
	self.width = platform.window:width() - 2
	self.y = self.titlebary + 20
	self.titlebarwidth = platform.window:width()
	self.cirbx = self.titlebarx + (self.titlebarwidth / 2) - 4
	self.cirby = (self.titlebary + self.titlebarheight / 4) - 2
	self.allowevents = false
	I()
end
function form:restoreSettings()
	self.titlebarx = self.valsavelist.x[1]
	self.titlebary = self.valsavelist.y[1]
	self.titlebarwidth = self.valsavelist.width[1]
	self.height = self.valsavelist.height[1]
	self.x = self.valsavelist.bx[1]
	self.y = self.valsavelist.by[1]
	self.width = self.valsavelist.bw[1]
	self.cirbx = self.valsavelist.cirbx[1]
	self.cirby = self.valsavelist.cirby[1]
	self.cirbx = self.titlebarx + (self.titlebarwidth / 2) - 4
	self.cirby =  (self.titlebary + self.titlebarheight / 4) - 2
	self.fullscreen = false
	self.allowevents = true
	I()
end
function form:mouseMove(x, y)
	if self.moveable and self.isdrawn and self.focused then
		cursor.set("drag grab")
		self.titlebarx = x - self.xvar
		self.titlebary = y - self.yvar
		self.cirbx = self.titlebarx + (self.titlebarwidth / 2) - 4
		self.cirby =  (self.titlebary + self.titlebarheight / 4) - 2
		self.x = self.titlebarx + 1
		self.y = self.titlebary + 20
		I()
	end
end
