--This basicly is the screen manager and window class. Window classes only use right now is to be inherited from

function DrawScreen(gc)
	for _, win in pairs(wndTbl) do
		if win.isdrawn then
		win:paint(gc)
		end
	end
end

--Create the classes
window = class()

wndTbl = {}
function window:init(x, y, width, height, isdrawn, focused)
	self.x = x
	self.y = y
	self.wbx = x
	self.wby = y
	self.width = width
	self.height = height
	self.isdrawn = isdrawn
	self.controls = {}
	self.dialogs = {}
	self.focused = focused
	table.insert(wndTbl, self)
end
function window:paint(gc)
	self:drawControls(gc)
	for _, Dialog in pairs(self.dialogs) do
		Dialog:paint(gc)
	end
end

function window:drawControls(gc)
	for _, control in pairs(self.controls) do
		control:paint(gc)
	end
end
function window:udateControl(control)
	control.x = control.xoff + self.x
	control.y = control.yoff + self.y
end
function window:enterKey()
	for _, control in pairs(self.controls) do
		if control.selected then
			control:enterKey()
			break
		end
	end
end
function window:mouseDown(x, y)
	if self.focused then
		for _, control in pairs(self.controls) do
			control:checkClick(x, y)
		end
		for _, dialog in pairs(self.dialogs) do
			if dialog.isdrawn then
				dialog:checkClick(x, y)
				break
			end
		end
		I()
	end
end
function window:charIn(ch)
	for _, control in pairs(self.controls) do
		if control.selected and control.type == "txt"then
			control:charIn(ch)
			break
		end
	end
end
function window:backspaceKey()
	for _, control in pairs(self.controls) do
		if control.selected and control.type == "txt" then
			control:backspaceKey()
			break
		end
	end
end
function window:getFocus()
	if curwin() == nil then
		self.focused = true
	end
	if curwin().allowevents then
		table.remove(wndTbl, findwndInd(self))
		table.insert(wndTbl, self)
		curwin().focused = false
		return true
	end
end
function curwin()
	for _, wnd in pairs(wndTbl) do
		if wnd.focused then
			return wnd
		end
	end
end
function findwndInd(wnd)
	for i = 1, #wndTbl do
		if wndTbl[i] == wnd then
			return i
		end
	end
end
function Clicks(x, y)
	for i = #wndTbl, 1, -1 do
		if wndTbl[i].isdrawn and not(wndTbl[i].moveable) then
			if not(wndTbl[i].fullscreen) and (x >= wndTbl[i].cirbx and x <= wndTbl[i].cirbx + 5) and (y >= wndTbl[i].cirby and y <= wndTbl[i].cirby + 5) then
				wndTbl[i]:setFull()
			elseif wndTbl[i].fullscreen and (x >= wndTbl[i].cirbx and x <= wndTbl[i].cirbx + 5) and (y >= wndTbl[i].cirby and y <= wndTbl[i].cirby + 5) then
				wndTbl[i]:restoreSettings()
				break
			elseif (x >= wndTbl[i].cirbx + 8 and x <= wndTbl[i].cirbx + 13) and (y >= wndTbl[i].cirby and y <= wndTbl[i].cirby + 5) then
				wndTbl[i]:close()
				break
			elseif not(wndTbl[i].fullscreen) and (x >= wndTbl[i].titlebarx and x <= wndTbl[i].titlebarx + wndTbl[i].titlebarwidth) and (y >= wndTbl[i].titlebary and y <= wndTbl[i].titlebary + 20) then
				wndTbl[i]:wasclicked(x, y)
				break
			end
			if wndTbl[i].focused then
				wndTbl[i]:mouseDown(x, y)
			end
			if wndTbl[i].isdrawn and not(wndTbl[i].moveable) and wndTbl[i].focused and x >= wndTbl[i].x and x <= wndTbl[i].x + wndTbl[i].width and y >= wndTbl[i].y and y <= wndTbl[i].y + wndTbl[i].height - 20 then
				break
			end
			if wndTbl[i].isdrawn and not(wndTbl[i].moveable) and not(wndTbl[i].focused) and x >= wndTbl[i].x and x <= wndTbl[i].x + wndTbl[i].width and y >= wndTbl[i].y and y <= wndTbl[i].y + wndTbl[i].height - 20 then
				wndTbl[i].focused = wndTbl[i]:getFocus()
				I()
				break
			end
		end
		if wndTbl[i].isdrawn and wndTbl[i].moveable then
			wndTbl[i]:checkUnclick()
			break
		end
	end
end
function I()
	platform.window:invalidate()
end
